# 第三章.嵌入式的linux软件开发包 #
linux嵌入式的软件开发包（ELDK）包含由gun社区提供的跨平台开发工具，比如compilers, binutils, gdb，等等...以及一些预建目标的开发工具和类库来为目标系统提供某些必要的功能。
这些工具包是完全免费开源的，包括所有的补丁，扩展，源代码，以及用来构建项目的脚本。
一些[ELDK][1]有两个版本，他们都是用 Glibc resp，uClibc 作为主要的c库来编译链接目标包。
这些包的安装是基于rpm的包管理器来实现的。
## 1.ELDK的可用性 ##

 - 来自[DENX Computer Systems][2]的DVD-ROM。
 - 从下列服务器下载：

| [ftp://ftp.denx.de/pub/eldk/][3] | [http://www.denx.de/ftp/pub/eldk/][4] |
| --------------------------- | -------------------------------- |

 - 也可以从下列下载镜像下载：

| FTP                                                    | HTTP                                                    |
| ------------------------------------------------------ | ------------------------------------------------------- |
| [ftp://ftp-stud.hs-esslingen.de/pub/Mirrors/eldk/][5]  | [http://ftp-stud.hs-esslingen.de/pub/Mirrors/eldk/][6]  |
| [ftp://mirror.switch.ch/mirror/eldk/][7]               | [http://mirror.switch.ch/ftp/mirror/eldk/][8]           |
| not available                                          | [http://mira.sunsite.utk.edu/eldk/][9]                  |
| [ftp://ftp.sunet.se/pub/Linux/distributions/eldk/][10] | [http://ftp.sunet.se/pub/Linux/distributions/eldk/][11] |                                                  |
## 2.如何获取ELDK的帮助 ##
[ELDK][12]的社区支持是可用的，可以通过如下的邮件列表：[ ELDK Mailing List][13]。
以前邮件列表的讨论内容都可以从[ELDK archives][14]获取到。
商业支持也是可用的。请随时联系：[DENX Software Engineering GmbH][15]。

## 3.支持的主机系统 ##
[ELDK][16]可以安装到以下系统主机中运行
    
 - Fedora Core 4, 5, 6 Fedora 7, 8, 9, 10, 11, 12 
 - Red Hat Linux 7.3, 8.0, 9 
 - SuSE Linux 8.x, 9.0, 9.1, 9.2, 9.3, 10.0 
 - OpenSUSE 10.2, 10.3 (32 Bit); OpenSUSE 11.0 (32 and 64 Bit) 
 - Debian 3.0 (Woody), 3.1 (Sarge) and 4.0 (Etch) 
 - Ubuntu 4.10, 5.04, 6.10, 8.04, 9.04, 9.10, 10.04 
 - FreeBSD 5.0 

注意：有一点可能是必须的，这也是经常被提到的，你必须把你的主机系统里面的所有软件更新到最新的版本。例如，在Fedora中，你可以用apt-get或yum来保持你的系统状态最新。
## 4.支持的目标架构 ##
    [ELDK][17]包含了目标组件，并且支持为如下power架构（[Power Architecture][18]）的主机创建代码。
    

 - ppc_4xx = AMCC 4xx processors without FPU
 - ppc_4xxFP = AMCC 4xx processors with FPU (440EP, 440EPx) 
 - ppc_6xx = PowerPC processors based on 60x cores with FPU (This includes support for MPC5xxx, 7xx, 82xx, 83xx and P40xx processors). 
 - ppc_74xx = 74xx processors
(This includes support for MPC86xx processors). 

 - ppc_8xx = MPC8xx processors without FPU 
 - ppc_85xx = MPC85xx processors (without FPU, but with a SPE) 
 - ppc_85xxDP = MPC8544 and similar processors using a e500v2 core (without FPU, but with a V.2 SPE); this includes the P10xx and P20xx QorIQ processors, too. 
 - ppc64 = 64 bit Power Architecture processors with FPU (for example, PA6T) 
 - 
    当然，也有支持Arm和Mips系统的[ELDK][19]
## 5. 安装 ##
稳定版本的ELDK是以ISO镜像的形式存在的，这种文件的优点在于既可以烧录在光盘上，也可以通过linux回环设备驱动直接挂载在主机上。
对于power体系的目标主机，ELDK分成三个独立的ELDK ISO镜像版本，一个的目标是4XX系列处理器（AMCC），一个的目标是PP64系列的处理器，另一个的目标是8xx, 6xx, 74xx以及85xx 系列的处理器，也就是大名鼎鼎的飞思卡尔系列的。这使得ISO映像符合标准的DVDROM媒体。
如果你没有被DVDROM 的大小限制， 但仍然会包含所有32位的目标的一个单一的镜像 。
### 5.2. 下载ELDK ###
在这里要说明的是，你也可以从以下站点之一下载现成的ELDK镜像：
[http://www.denx.de/wiki/view/DULG/ELDKAvailability][20]
首先，你要先切换到一个有足够大的剩余空间的目录，对于POWER架构的ELDK版本，你至少需要一个1.6 GiB的空间，如果你还想要在这个目录创建一个ISO文件，那么你至少需要3.2GiB的文件。

然后，你可以用类似于wget 或 ncftpget 从镜像站点的 ppc-linux-x86/iso 目录中下载镜像，例如：

    bash$ wget ftp://ftp.sunet.se/pub/Linux/distributions/eldk/4.2/ppc-linux-x86/iso/ppc-2008-04-01.iso
    

如果你想下载整个ELDK目录树，你可以使用FTP客户端，例如：

    bash$ ncftp ftp.sunet.se
    ...
    ncftp / > cd /pub/Linux/distributions/eldk/4.2
    ncftp /pub/Linux/distributions/eldk/4.2 > bin
    ncftp /pub/Linux/distributions/eldk/4.2 > get -R ppc-linux-x86/distribution
    ...
    ncftp /pub/Linux/distributions/eldk/4.2 > bye

注：如果你不想使用ncftp 工具，你可以从[http://www.ncftp.com/download/][21]下载NcFTP 客户端

下面的是一些ELDK目录下的可执行的文件（二进制代码或脚本），首先你要确定他们在你的本地副本中有可执行权限：

    bash$ for file in \
    >       tools/bin/rpm \
    >       tools/usr/lib/rpm/rpmd \
    >       install \
    >       ELDK_MAKEDEV \
    >       ELDK_FIXOWNER
    > do
    > chmod +x ppc-linux-x86/distribution/$file
    > done 
    
现在，让我们来从本地目录树创建一个ISO镜像：

    bash$ mkisofs \
    > -A "ELDK-4.2 -- Target: PowerPC -- Host: x86 Linux" \
    > -publisher "(C) `date "+%Y"` DENX Software Engineering,   www.denx.de" \
    > -p "`id -nu`@`hostname` -- `date`" \
    > -V ppc-linux-x86 \
    > -l -J -R -o eldk-ppc-linux-x86.iso ppc-linux-x86/distribution

这将会在本地目录创建一个名为 eldk-ppc-linux-x86.iso 的镜像文件，它可以被烧写到DVD或者用linux回环设备驱动挂载，
[原文地址:http://www.denx.de/wiki/view/DULG/ELDK][22]


  [1]: http://www.denx.de/wiki/DULG/ELDK
  [2]: office@denx.de
  [3]: ftp://ftp.denx.de/pub/eldk/
  [4]: http://www.denx.de/ftp/pub/eldk/
  [5]: ftp://ftp-stud.hs-esslingen.de/pub/Mirrors/eldk/
  [6]: http://ftp-stud.hs-esslingen.de/pub/Mirrors/eldk/
  [7]: ftp://mirror.switch.ch/mirror/eldk/
  [8]: http://mirror.switch.ch/ftp/mirror/eldk/
  [9]: http://mira.sunsite.utk.edu/eldk/
  [10]: ftp://ftp.sunet.se/pub/Linux/distributions/eldk/
  [11]: http://ftp.sunet.se/pub/Linux/distributions/eldk/
  [12]: http://www.denx.de/wiki/DULG/ELDK
  [13]: http://lists.denx.de/mailman/listinfo/eldk
  [14]: http://lists.denx.de/pipermail/eldk/
  [15]: office@denx.de
  [16]: http://www.denx.de/wiki/DULG/ELDK
  [17]: http://www.denx.de/wiki/DULG/ELDK
  [18]: http://www.denx.de/wiki/DULG/PowerPC
  [19]: http://www.denx.de/wiki/DULG/ELDK
  [20]: http://www.denx.de/wiki/view/DULG/ELDKAvailability
  [21]: http://www.ncftp.com/download/
  [22]: http://www.denx.de/wiki/view/DULG/ELDK